package com.sato.printersample;

import com.sato.printer.Printer;

import android.app.Activity;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioGroup;

public class DrawQrCodeActivity extends Activity implements OnClickListener {

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_draw_qr_code);
		
		Button button = (Button) findViewById(R.id.button1);
		button.setOnClickListener(this);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_draw_qr_code, menu);
		return true;
	}

	public void onClick(View v) {
		EditText editText = (EditText) findViewById(R.id.editText1);
		if(editText.getText().toString().equals("")){
			editText.setText(" Label Printer");
		}
		String data = editText.getText().toString();
		
		editText = (EditText) findViewById(R.id.editText2);
		if(editText.getText().toString().equals("")){
			editText.setText("200");
		}
		int horizontalPosition = Integer.parseInt(editText.getText().toString());
		
		editText = (EditText) findViewById(R.id.editText3);
		if(editText.getText().toString().equals("")){
			editText.setText("100");
		}
		int verticalPosition = Integer.parseInt(editText.getText().toString());
		
		int model = Printer.QR_CODE_MODEL1;
		RadioGroup radioGroup = (RadioGroup) findViewById(R.id.radioGroup1);
		if (radioGroup.getCheckedRadioButtonId() == R.id.radio1) {
			model = Printer.QR_CODE_MODEL2;
		}
		
		int eccLevel = Printer.ECC_LEVEL_7;
		radioGroup = (RadioGroup) findViewById(R.id.radioGroup2);
		switch (radioGroup.getCheckedRadioButtonId()) {
		case R.id.radio3:
			eccLevel = Printer.ECC_LEVEL_15;
			break;
			
		case R.id.radio4:
			eccLevel = Printer.ECC_LEVEL_25;
			break;
			
		case R.id.radio5:
			eccLevel = Printer.ECC_LEVEL_30;
			break;
		}
		
		editText = (EditText) findViewById(R.id.editText4);
		if(editText.getText().toString().equals("")){
			editText.setText("9");
		}
		int size = Integer.parseInt(editText.getText().toString());
		
		int rotation = Printer.ROTATION_NONE;
		radioGroup = (RadioGroup) findViewById(R.id.radioGroup3);
		switch (radioGroup.getCheckedRadioButtonId()) {
		case R.id.radio6:
			rotation = Printer.ROTATION_NONE;
			break;
		case R.id.radio7:
			rotation = Printer.ROTATION_90_DEGREES;
			break;
			
		case R.id.radio8:
			rotation = Printer.ROTATION_180_DEGREES;
			break;
			
		case R.id.radio9:
			rotation = Printer.ROTATION_270_DEGREES;
			break;
		}
		
		MainActivity.mPrinter.drawQrCode(data, horizontalPosition, verticalPosition, model, eccLevel, size, rotation);
		MainActivity.mPrinter.print(1, 1);
	}
}
